--- old/usr/src/uts/common/fs/zfs/dbuf.c	2016-04-06 14:26:56.408667608 -0400
+++ new/usr/src/uts/common/fs/zfs/dbuf.c	2016-04-06 14:26:56.415994042 -0400
@@ -58,7 +58,8 @@
 
 #ifndef __lint
 extern inline void dmu_buf_init_user(dmu_buf_user_t *dbu,
-    dmu_buf_evict_func_t *evict_func, dmu_buf_t **clear_on_evict_dbufp);
+    dmu_buf_evict_func_t *evict_func_prep, dmu_buf_evict_func_t *evict_func,
+    dmu_buf_t **clear_on_evict_dbufp);
 #endif /* ! __lint */
 
 /*
@@ -299,6 +300,9 @@
 		*dbu->dbu_clear_on_evict_dbufp = NULL;
 #endif
 
+	if (dbu->dbu_evict_func_prep != NULL)
+		dbu->dbu_evict_func_prep(dbu);
+
 	/*
 	 * Invoke the callback from a taskq to avoid lock order reversals
 	 * and limit stack depth.
